Subject: Re: linux-next: build failure after merge of the kvm tree

From: Stephen Rothwell <[email-masked]>
Date: Wed, 28 May 2025 16:44:07 +1000

Hi Paolo,

On Wed, 28 May 2025 07:37:57 +0200 Paolo Bonzini <[email-masked]> wrote:
>
> On Wed, May 28, 2025 at 7:28 AM Stephen Rothwell <[email-masked]> wrote:
> >
> > After merging the kvm tree, today's linux-next build (x86_64 allmodconfig)
> > failed like this:
> >
> > error[E0425]: cannot find function `mutex_trylock` in crate `bindings`  
> >    --> rust/kernel/sync/lock/mutex.rs:129:41  
> >     |
> > 129 |         let result = unsafe { bindings::mutex_trylock(ptr) };
> >     |                                         ^^^^^^^^^^^^^ help: a function with a similar name exists: `mutex_lock`
> >     |
> >    ::: /home/sfr/next/x86_64_allmodconfig/rust/bindings/bindings_helpers_generated.rs:265:5
> >     |
> > 265 |     pub fn mutex_lock(lock: *mut mutex);
> >     |     ------------------------------------ similarly named function `mutex_lock` defined here
> >
> > error: aborting due to 1 previous error  
> 
> I thought that since Rust failures wouldn't have to be fixed by
> non-Rust maintainers, they wouldn't block merging of non-Rust trees in
> linux-next?

I am sorry, but I am not sure how that is supposed to work.  (Do I
disable RUST in my builds - thereby possibly missing other build
problems?)  In this case you can probably not even do an allmodconfig
build of the kvm tree alone if you have rustc etc installed, right?

BTW, the only bit of the kvm tree not merged into linux-next today is
the kvm-lockdep-common topic branch that was merged overnight (my time).

> In this case it's not a problem to fix it up at all (I'll send a patch
> to Miguel as soon as I've taken the little guy to school); it's just
> to understand what's to expect.

That patch needs to go into your tree (with Miguel's Ack if necessary)
otherwise as soon as Linus merges your tree, his allmodconfig build
will be broken and he will (probably) unmerge your tree and let you
know (and wonder why I didn't pick it up).

I don't know what to tell you about expectations, sorry.
-- 
Cheers,
Stephen Rothwell